unit MainForm;
{ a jour le 30/10/00 }
{ 21.02.01 : FO : initialisation d'un nouveau spectre 'proj' dans la liste deuxd     }
{                 pour une utilisation comme stockage des projections                }
{ 06.03.01 : FO : initialisation de tous les champs des spects                       }
{ 06.04.01 : FO : ajout d'une fonction "print" pour pouvoir imprimer les spectres 2D }
{                 petit problme: le contenu des combo ne s'imprime pas!             }
{ 30.04.01 : FO : cette version devient la version officielle 1.0                    }
{                 Nom officiel : "TraitementSpectres"                                }
{                 les appels aux bases de donnes ont t supprims                  }
{                 On perd aussi le composant activeX VCF1 qui permettait de voir les tableaux de data }
{                 cela simplifie la distribution du programme (sous la forme d'un simple excutable)  }
{                 Le postionnement des fenetres est optimis pour un ecran 1024 x 768    }
{                 Il est souhaitable d'avoir une connection reseau pour le bug reporting }
{                 La procedure "reorganiser" a t vide de sa substance                 }
{                * le fichier d'aide doit etre dans le meme repertoire que le fichier executable }
{                  quels sont les fichiers indispensables pour l'aide et qu'il faut donner avec le .exe? }
{ 30.10.01 : FO : amlioration du message de sortie et du placement des fenetres    }
{ 26.11.01 : FO : sortie du programme simplifie                                    }
{ 02.04.02 : FO : correction d'un bug dans l'inialisation des spectres 2D           }
{ =========== preparation de la release 1.4 ============                            }
{ NOUVEAU NOM DU PROGRAMME : SpectraProcessor                                       }
{ 16.07.02 : Fo : * upgrade des menus                                               }
{                 * upgrade du miniparser de graph1D pour qu'il fonctionne a nouveau}
{                   correction du probleme du aux abscisses mal initialises        }
{                   NOTA : il faut que les equations soient homognes               }
{                 * retrac automatique des curseurs lors d'un changement de spectre}
{                   c'est particulirement utile pour les comparaisons              }
{                   MAIS il reste un bug si les spectres ne sont pas de meme taille }
{                   nouveau menu pour les oprations sur les spectres 2D            }
{                   > oprations entre spectres et oprations scalaires             }
{                 * nouvelle fonction d'extraction des data : menu [operations]     }
{ 23.07.02:FO:* utilisation de JvFormPlace pour garder la position des formulaires en mmoire   }
{ 30.07.02:FO:* le formulaire Editadat permet a nouveau de visualiser les spectres und et deuxd }
{ 19.08.02:FO:* implementation of Nexus format                                      }
{               Sauvegarde spectre 1D et 2D ok, compression ok                      }
{               paramtres exprimentaux sauvegards uniquement dnas le dossier racine ? }
{ 26.09.02 : FO : autosave procedure in graph1D for the miniparser                  }
{ 01.11.02 : FO : possiblite de changer le rapport d'aspect                         }
{                 derniee petit problme : lorsuae le rapport d'aspect n'est pas 1  }
{                les curseurs ne se trace plus finement que 1 pixel                 }
{                consquence : quand on clique, le curseur n'est pas pile sous la souris }
{ 07.01.03 : FO : utilisation du rpertoire "common" qui contient les units communes  tous les projets }
{ ================================================================================= }
{ A FAIRE                                                                           }
{ * unifier les extensions des sauvegardes                                      }
{ * mettre au clair l'histoire du moniteur                                      }
{ * NEXUS : activer la compression des data                                     }
{ * les coupes 1D ne se rafraichissent pas automatiquemtn quand un nouveau spectre 2D est cre }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus,editdata,xygraph, Db, Graph2D, Graph1D, SommeSpectre2D,
  StdCtrls, Spin, JclShell, JvComponent, JvHtmlParser, JvSysComp;

const
wm_fermeture=$400+wm_user;
wm_redessine=$403+wm_user;
wm_reorganiser=$406+wm_user;

type
  Tprincipalform = class(TForm)
    MainMenu1: TMainMenu;
    nouvelle: TMenuItem;
    nouvelle1: TMenuItem;
    N1D1: TMenuItem;
    N1D2: TMenuItem;
    N1: TMenuItem;
    supprimer2: TMenuItem;
    OpenDialog1: TOpenDialog;
    Aide1: TMenuItem;
    Apropos1: TMenuItem;
    Utiliserlaide1: TMenuItem;
    Index1: TMenuItem;
    Main1: TMenuItem;
    Help1: TMenuItem;
    Parser1: TMenuItem;
    JvCreateProcess1: TJvCreateProcess;
    N2: TMenuItem;
    Fitting: TMenuItem;
    Graph2D1: TMenuItem;
    Graph1D1: TMenuItem;
    Parser2: TMenuItem;
    EditData1: TMenuItem;
    GPIB1: TMenuItem;
    InitializeKeithleyCEC1: TMenuItem;
    InitializeKeithleyCECPCMCIA1: TMenuItem;
    InitializeNatInstr1: TMenuItem;
    procedure nouvelleClick(Sender: TObject);
    procedure supprimer1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N1D1Click(Sender: TObject);
    {procedure editiondesmoteurs1Click(Sender: TObject);}
    {procedure Ajouter1Click(Sender: TObject);}
    procedure Index1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BUGREPORT1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure Parser1Click(Sender: TObject);
    procedure FittingClick(Sender: TObject);
    procedure Graph1D1Click(Sender: TObject);
    procedure Graph2D1Click(Sender: TObject);
    procedure EditData1Click(Sender: TObject);
    procedure Parser2Click(Sender: TObject);
    procedure InitializeKeithleyCEC1Click(Sender: TObject);
    procedure InitializeKeithleyCECPCMCIA1Click(Sender: TObject);

  private
    { Dclarations prives}
  protected
    {procedure sequenceclick(sender: tobject);
    procedure corrigemenu;}
  public
    { Dclarations publiques}
    items:array of tmenuitem;
    procedure redessiner;
    procedure wmredessine(var msg:tmessage); message wm_redessine;
  end;

var
  principalform: Tprincipalform;
  gr2d:array[1..4] of tGraph2Dform;
  gr1d:array[1..4] of tGraph1dform;

implementation

uses {editMoteursBase,} interpreteur, {editFenetresBaseParam, {EmailUnit, }
  about, FitForm;
{$R *.DFM}

procedure Tprincipalform.nouvelleClick(Sender: TObject);
var
tf:boolean;
i:integer;
begin
tf:=false;
i:=1;
while (not tf) and (i<=4) do
begin
   if gr2d[i]=nil then begin
                    gr2d[i]:=tGraph2dform.create(self,128,128);
                    tf:=true;
                    end;
   i:=i+1;
end;
end;

procedure Tprincipalform.supprimer1Click(Sender: TObject);
var
i:integer;
begin
for i:=1 to 4 do begin
if activemdichild=gr1d[i] then
sendmessage(gr1d[i].handle,wm_fermeture,0,0);{suppression}
if activemdichild=gr2d[i] then
sendmessage(gr2d[i].handle,wm_fermeture,0,0);{suppression}
end;
end;

procedure Tprincipalform.FormCreate(Sender: TObject);
var
ind:integer;
i,j,k:integer;
begin
  SourceDirectory:=GetCurrentDir+'\';
{ cration des listes des spectres 1D, 2D et 3D      }
troisd:=spectlist.create;
deuxd:=spectlist.create;
und:=spectlist.Create;
{ initialisation des spectres 2D }
ind:=deuxd.addspectre('ACUP',128,128,1);
deuxd.spect[ind].comment:='spectre upup';
deuxd.spect[ind].typex:='raw';
deuxd.spect[ind].typey:='raw';
for i:=0 to 127 do
  for j:=0 to 127 do
  begin
    deuxd.spect[ind].data[i,j,0].x:=i;
    deuxd.spect[ind].data[i,j,0].y:=j;
    deuxd.spect[ind].data[i,j,0].lt:=0;
    deuxd.spect[ind].data[i,j,0].z:=100*exp(-sqr(i-64)/10000)*exp(-sqr(j-64)/10000);
  end;

ind:=deuxd.addspectre('ACDOWN',128,128,1);
deuxd.spect[ind].comment:='spectre updown';
deuxd.spect[ind].typex:='raw';
deuxd.spect[ind].typey:='raw';
for i:=0 to 127 do
  for j:=0 to 127 do
  begin
    deuxd.spect[ind].data[i,j,0].x:=i;
    deuxd.spect[ind].data[i,j,0].y:=j;
    deuxd.spect[ind].data[i,j,0].lt:=0;
    deuxd.spect[ind].data[i,j,0].z:=40*exp(-sqr(i-128)/10000)*exp(-sqr(j-32)/10000);
  end;

{ creation du spectre utilis pour les projections }
ind:=deuxd.addspectre('PROJ',64,256,1); { les tailles seront modifies }
deuxd.spect[ind].comment:='projected spectrum';
deuxd.spect[ind].typex:='raw';
deuxd.spect[ind].typey:='raw';
for i:=0 to 63 do
  for j:=0 to 255 do
  begin
    deuxd.spect[ind].data[i,j,0].x:=i;
    deuxd.spect[ind].data[i,j,0].y:=j;
    deuxd.spect[ind].data[i,j,0].lt:=0;
    deuxd.spect[ind].data[i,j,0].z:=sin(i+j);
  end;

{ creation des spectres 1D }
ind:=und.addspectre('C1H',512,1,1);
und.spect[ind].comment:='curseur 1, coupe horizontale';
und.spect[ind].typex:='reflec';
und.spect[ind].typey:='single';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;
ind:=und.addspectre('C1V',512,1,1);
und.spect[ind].comment:='rflectivit downdown';
und.spect[ind].typex:='reflec';
und.spect[ind].typey:='single';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;
ind:=und.addspectre('C2H',512,1,1);
und.spect[ind].comment:='rflectivit downdown';
und.spect[ind].typex:='reflec';
und.spect[ind].typey:='single';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;

ind:=und.addspectre('C2V',512,1,1);
und.spect[ind].comment:='rflectivit downdown';
und.spect[ind].typex:='reflec';
und.spect[ind].typey:='single';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;

ind:=und.addspectre('PH',512,1,1);
und.spect[ind].comment:='projection horizontale';
und.spect[ind].typex:='raw';
und.spect[ind].typey:='raw';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;

ind:=und.addspectre('PV',512,1,1);
und.spect[ind].comment:='projection verticale';
und.spect[ind].typex:='raw';
und.spect[ind].typey:='raw';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;

WindowState := wsMaximized;

{ creation du spectre 3D  }
ind:=troisd.addspectre('data3D',32,64,8);
for i:=0 to 31 do
   for j:=0 to 63 do
       for k:=0 to 7 do
       begin
          troisd.spect[ind].data[i,j,k].x:=i;
          troisd.spect[ind].data[i,j,k].y:=j;
          troisd.spect[ind].data[i,j,k].z:=(k+1)*exp(-sqr(i-64)/10000)*exp(-sqr(j-64)/10000);
          troisd.spect[ind].data[i,j,k].lt:=k;
       end;
troisd.spect[ind].comment:='spectre updown';
troisd.spect[ind].typex:='raw';
troisd.spect[ind].typey:='raw';
troisd.spect[ind].typeLT:='lambda';

{corrigemenu;} { a quoi ca sert ??? }
end;

procedure Tprincipalform.N1D1Click(Sender: TObject);
var
tf:boolean;
i:integer;
begin
tf:=false;
i:=1;
while (not tf) and (i<=4) do begin
if gr1d[i]=nil then begin
 gr1d[i]:=tgraph1dform.create(self);
 tf:=true;
end;
i:=i+1;
end;
end;

procedure Tprincipalform.wmredessine(var msg:tmessage);
begin
redessiner;
end;

procedure Tprincipalform.redessiner;
var
i:integer;
begin
for i := MDIChildCount-1 downto 0 do
sendmessage(mdichildren[i].handle,wm_redessiner,0,0);
end;


procedure Tprincipalform.Index1Click(Sender: TObject);
begin
  Application.HelpFile := SourceDirectory+'help\interprethelp.HLP';
  Application.HelpCommand(HELP_FINDER, 0);
end;

procedure Tprincipalform.FormClose(Sender: TObject;
  var Action: TCloseAction);
var ButtonSelected:word;
begin
     ButtonSelected:=MessageDlg('DO YOU WANT TO QUIT THE PROGRAM ?',mtWarning,[mbNo,mbYes],0);
{     ButtonSelected:=MessageDlg('ARE YOU REALLY SURE THAT YOU ARE NOT QUITTING PCANYWHERE ?',mtConfirmation,[mbNo,mbYes],0); }
     if ButtonSelected=mrYes then action:=caFree else begin action:=caNone end;
end;

procedure Tprincipalform.BUGREPORT1Click(Sender: TObject);
begin
{     SmtpForm.WindowState:=wsNormal; }
end;

procedure Tprincipalform.Apropos1Click(Sender: TObject);
begin
     AboutBox.visible:=true;
end;

procedure Tprincipalform.Help1Click(Sender: TObject);
var s1,s2: Pchar;
begin
  JvCreateProcess1.CommandLine:='explorer '+SourceDirectory+'SpectraProcessorHelp\SP_Manual.htm';
  JvCreateProcess1.Run;
end;

procedure Tprincipalform.Parser1Click(Sender: TObject);
begin
  JvCreateProcess1.CommandLine:='explorer '+SourceDirectory+'ParserHelp\parserManual.htm';
  JvCreateProcess1.Run;
end;

procedure Tprincipalform.FittingClick(Sender: TObject);
begin
  FittingForm.WindowState:=wsNormal;
end;

procedure Tprincipalform.Graph1D1Click(Sender: TObject);
begin
  Graph1Dform.WindowState:=wsNormal;
end;

procedure Tprincipalform.Graph2D1Click(Sender: TObject);
begin
  Graph2DForm.WindowState:=wsNormal;
end;

procedure Tprincipalform.EditData1Click(Sender: TObject);
begin
  DataEditForm.WindowState:=wsNormal;
end;

procedure Tprincipalform.Parser2Click(Sender: TObject);
begin
  InterpreteurForm.WindowState:=wsNormal;
end;

procedure Tprincipalform.InitializeKeithleyCEC1Click(Sender: TObject);
begin
{     gpibinitialize(21,0);
     setoutputeos(13,0);
     setinputeos(13);
     settimeout(1000); }
end;

procedure Tprincipalform.InitializeKeithleyCECPCMCIA1Click(Sender: TObject);
begin
{     setport(0,$1400);
     gpibinitialize(21,0);
     setoutputeos(13,0);
     setinputeos(13);
     settimeout(1000); }
end;

end.
